int dirlist(int sid)
{
#ifdef WIN32
	struct	direct *dentry;
#else
	struct	dirent *dentry;
#endif
	DIR	*handle;
	char	file[1024];
	char	index[1024];
	char	showfile[1024];
	struct	stat sb;
	char	*directory;
	char timebuf[100];
	time_t t;

	if (strncmp(conn[sid].dat->in_RequestURI, "/", 1)!=0) {
		return -1;
	}
	directory=conn[sid].dat->in_RequestURI+1;
	snprintf(file, sizeof(file)-1, "%s/%s", config.server_htdocs_dir, directory);
	decodeurl(file);
	fixslashes(file);
	while ((file[strlen(file)-1]=='\\')||(file[strlen(file)-1]=='/')) { file[strlen(file)-1]='\0'; };
	if (strstr(file, "..")!=NULL) return -1;
	snprintf(index, sizeof(index)-1, "%s/%s/index.html", config.server_htdocs_dir, directory);
	decodeurl(index);
	fixslashes(index);
	if (stat(index, &sb)==0) {
		sendfile(sid, index);
		return 0;
	}
	if (stat(file, &sb)!=0) return -1;
	if (!(sb.st_mode & S_IFDIR)) return sendfile(sid, file);
	t=time((time_t*)0);
	strftime(timebuf, sizeof(timebuf), "%b %d %H:%M:%S", localtime(&t));
	send_header(sid, 0, 200, "OK", "1", "text/html", -1, -1);
	prints("<CENTER>\n<TABLE BORDER=1 CELLPADDING=2 CELLSPACING=0 WIDTH=90%%>\n");
	prints("<TR BGCOLOR=#00A5D0><TH COLSPAN=4>Index of %s</TH></TR>\n", conn[sid].dat->in_RequestURI);
	prints("<TR BGCOLOR=#E0E0E0>");
	prints("<TH width=20%%>Filename</TH><TH width=10%%>Size</TH>");
	prints("<TH width=10%%>Date</TH><TH width=60%%>Description</TH></TR>\n");
	handle=opendir(file);
	while ((dentry=readdir(handle))!=NULL) {
		snprintf(file, sizeof(file)-1, "%s/%s%s", config.server_htdocs_dir, directory, dentry->d_name);
		fixslashes(file);
		stat(file, &sb);
		if (strcmp(".", dentry->d_name)==0) continue;
		if ((strcmp("..", dentry->d_name)==0)&&(strcmp("/files/", conn[sid].dat->in_RequestURI)==0)) continue;
		if (strcmp("..", dentry->d_name)==0) {
			prints("<TR BGCOLOR=#F0F0F0><TD COLSPAN=4><IMG SRC=/images/foldero.gif>");
			prints("<A HREF=%s/> Parent Directory</A></TD>\n", dentry->d_name);
			continue;
		}
		strftime(timebuf, sizeof(timebuf), "%b %d %Y %H:%M", localtime(&sb.st_mtime));
		memset(showfile, 0, sizeof(showfile));
		snprintf(showfile, sizeof(showfile)-1, "%s", dentry->d_name);
		prints("<TR BGCOLOR=#F0F0F0><TD ALIGN=left NOWRAP>");
		if (sb.st_mode & S_IFDIR) {
			prints("<IMG SRC=/images/folder.gif>&nbsp;<A HREF=");
			printhex("%s", showfile);
			prints("/>%s/</A></TD>", dentry->d_name);
		} else {
			prints("<IMG SRC=/images/default.gif>&nbsp;<A HREF=");
			printhex("%s", showfile);
			prints(">%s</A></TD>", dentry->d_name);
		}
		if (sb.st_size>1048576) {
			prints("<TD ALIGN=right NOWRAP>%10.1f M</TD>\n", (float)sb.st_size/1048576.0);
		} else {
			prints("<TD ALIGN=right NOWRAP>%10.1f K</TD>\n", (float)sb.st_size/1024.0);
		}
		prints("<TD ALIGN=right NOWRAP>%s</TD>\n", timebuf);
		prints("<TD ALIGN=left NOWRAP>&nbsp;</TD></TR>\n");
	}
	closedir(handle);
	prints("</TABLE>\n");
	prints("</CENTER>\n");
	prints("</BODY></HTML>\n");
	return 0;
}
