void flushheader(int sid)
{
	char line[256];

	if (conn[sid].dat->out_headdone) return;
	if (!conn[sid].dat->out_status) {
		conn[sid].dat->out_headdone=1;
		return;
	}
#ifdef DEBUG
logdata("\n[[[ FLUSHING HEADER ]]]\n");
#endif
	if ((conn[sid].dat->out_bodydone)&&(!conn[sid].dat->out_flushed)) {
		conn[sid].dat->out_ContentLength=strlen(conn[sid].dat->out_ReplyData);
	}
	if ((strcasecmp(conn[sid].dat->in_Connection, "Keep-Alive")==0)&&(conn[sid].dat->out_bodydone)) {
		snprintf(conn[sid].dat->out_Connection, sizeof(conn[sid].dat->out_Connection)-1, "Keep-Alive");
	} else {
		snprintf(conn[sid].dat->out_Connection, sizeof(conn[sid].dat->out_Connection)-1, "Close");
	}
	// Netscape and Mozilla don't know what a keepalive is
	if ((strcasestr(conn[sid].dat->in_UserAgent, "MSIE")==NULL)) {
		snprintf(conn[sid].dat->out_Connection, sizeof(conn[sid].dat->out_Connection)-1, "Close");
	}
	if (strcasestr(conn[sid].dat->in_Protocol, "HTTP/1.1")!=NULL) {
		snprintf(conn[sid].dat->out_Protocol, sizeof(conn[sid].dat->out_Protocol)-1, "HTTP/1.1");
	} else {
		snprintf(conn[sid].dat->out_Protocol, sizeof(conn[sid].dat->out_Protocol)-1, "HTTP/1.0");
	}
	snprintf(line, sizeof(line)-1, "%s %d OK\r\n", conn[sid].dat->out_Protocol, conn[sid].dat->out_status);
	send(conn[sid].socket, line, strlen(line), 0);
	if (strlen(conn[sid].dat->out_CacheControl)) {
		snprintf(line, sizeof(line)-1, "Cache-Control: %s\r\n", conn[sid].dat->out_CacheControl);
		send(conn[sid].socket, line, strlen(line), 0);
	}
	if (strlen(conn[sid].dat->out_Connection)) {
		snprintf(line, sizeof(line)-1, "Connection: %s\r\n", conn[sid].dat->out_Connection);
		send(conn[sid].socket, line, strlen(line), 0);
	}
	if (conn[sid].dat->out_bodydone) {
		snprintf(line, sizeof(line)-1, "Content-Length: %d\r\n", conn[sid].dat->out_ContentLength);
		send(conn[sid].socket, line, strlen(line), 0);
	}
	if (strlen(conn[sid].dat->out_Date)) {
		snprintf(line, sizeof(line)-1, "Date: %s\r\n", conn[sid].dat->out_Date);
		send(conn[sid].socket, line, strlen(line), 0);
	}
	if (strlen(conn[sid].dat->out_Expires)) {
		snprintf(line, sizeof(line)-1, "Expires: %s\r\n", conn[sid].dat->out_Expires);
		send(conn[sid].socket, line, strlen(line), 0);
	}
	if (strlen(conn[sid].dat->out_LastModified)) {
		snprintf(line, sizeof(line)-1, "Last-Modified: %s\r\n", conn[sid].dat->out_LastModified);
		send(conn[sid].socket, line, strlen(line), 0);
	}
	if (strlen(conn[sid].dat->out_Pragma)) {
		snprintf(line, sizeof(line)-1, "Pragma: %s\r\n", conn[sid].dat->out_Pragma);
		send(conn[sid].socket, line, strlen(line), 0);
	}
	snprintf(line, sizeof(line)-1, "Server: %s\r\n", SERVER_NAME);
	send(conn[sid].socket, line, strlen(line), 0);
	if (strlen(conn[sid].dat->out_ContentType)) {
		snprintf(line, sizeof(line)-1, "Content-Type: %s\r\n\r\n", conn[sid].dat->out_ContentType);
		send(conn[sid].socket, line, strlen(line), 0);
	} else {
		snprintf(line, sizeof(line)-1, "Content-Type: text/plain\r\n\r\n");
		send(conn[sid].socket, line, strlen(line), 0);
	}
	conn[sid].dat->out_headdone=1;
#ifdef DEBUG
logdata("\n[[[ DONE FLUSHING HEADER ]]]\n");
#endif
	return;
}

